#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
};

uniform float time;

in vec4 position;	// local space

out vec4 color;

//----------------------------------------------------------------
// TODO:
// 1) Morphing as interpolation between two points (object and cube).
// 2) Prevent extrapolation - e.g. use sin function.
//----------------------------------------------------------------

// Returns a value to multiply normalized input vector with to get a point on the unit cube.
float length_to_cube(in vec3 dir);

void main()
{
	color = vec4(vec3(0.f), 1.f);
	vec4 v = position;

	vec3 direction = normalize(v.xyz);
	float distance = length(v.xyz);
	float cube_distance = length_to_cube(v.xyz);

	//v.xyz = direction * distance;
	//v.xyz = direction * cube_distance;
	//v.xyz = direction * mix(distance, cube_distance, time);
	//v.xyz = direction * mix(distance, cube_distance, sin(time));
	v.xyz = direction * mix(distance, cube_distance, abs(sin(time)));

	gl_Position = m_pvm * v;
}

float length_to_cube(in vec3 dir)
{
	vec3 adir = abs(dir);
	return length(dir) / max(adir.x, max(adir.y, adir.z));
}
