#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
};

uniform float time;

in vec4 position;	// local space

out vec4 color;

//----------------------------------------------------------------
// TODO:
// 1) Morphing as interpolation between two points (object and sphere).
// 2) Prevent extrapolation - e.g. use sin function.
//----------------------------------------------------------------

void main()
{
	color = vec4(vec3(0.f), 1.f);
	vec4 v = position;

	vec3 direction = normalize(v.xyz);
	float distance = length(v.xyz);

	//v.xyz = direction * distance;
	//v.xyz = direction * 1.0;
	//v.xyz = direction * mix(distance, 1.0, time);
	//v.xyz = direction * mix(distance, 1.0, sin(time));
	v.xyz = direction * mix(distance, 1.0, abs(sin(time)));

	gl_Position = m_pvm * v;
}